//-*-c++-*-
#ifndef INCLUDED_string_util_h
#define INCLUDED_string_util_h

#include <string>
#include <vector>

//! some common string processing functions, for std::string
namespace string_util {
	//! returns lower case version of @a s
	std::string makeLower(const std::string& s);

	//! returns upper case version of @a s
	std::string makeUpper(const std::string& s);

	//! returns @a str with @a pre removed - if @a pre is not fully matched, @a str is returned unchanged
	std::string removePrefix(const std::string& str, const std::string& pre);
	
	//! removes whitespace (as defined by isspace()) from the beginning and end of @a str, and returns the result
	std::string trim(const std::string& str);
	
	//! parses the input string into an arg list, with corresponding offsets of each arg in the original input
	bool parseArgs(const std::string& input, std::vector<std::string>& args, std::vector<unsigned int>& offsets); 
};

/*! @file
 * @brief Describes some useful functions for string manipulation in the string_util namespace
 * @author ejt (Creator)
 *
 * $Author: ejt $
 * $Name: tekkotsu-2_4 $
 * $Revision: 1.4 $
 * $State: Exp $
 * $Date: 2005/06/01 05:47:49 $
 */

#endif
